VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Main Form"
   ClientHeight    =   4965
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7200
   LinkTopic       =   "Form1"
   ScaleHeight     =   4965
   ScaleWidth      =   7200
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Check1 
      Caption         =   "Show SubForm"
      Height          =   555
      Left            =   240
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   240
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 1999 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit
Implements IMessageSink

Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Const WM_MOVE = &H3
Private Const WM_SIZE = &H5
Private Const WM_SIZING = &H214
Private Const WM_MOVING = &H216

Private Const WM_ACTIVATE = &H6
Private Const WM_NCACTIVATE = &H86

Private WithEvents m_Sub As Form2
Attribute m_Sub.VB_VarHelpID = -1

Private Sub Check1_Click()
   If Check1.Value Then
      m_Sub.Show , Me
      Check1.Caption = "Hide Sub Form"
   Else
      m_Sub.Hide
      Check1.Caption = "Show Sub Form"
   End If
End Sub

Private Sub Form_Load()
   ' Hook into messages for this window.
   Call HookWindow(Me.hWnd, Me)
   
   ' Create, load, and hook messages for sub form.
   Set m_Sub = New Form2
   Load m_Sub
   Call HookWindow(m_Sub.hWnd, Me)
End Sub

Private Sub Form_Unload(Cancel As Integer)
   ' Always unhook before unloading!
   Call UnhookWindow(m_Sub.hWnd)
   Unload m_Sub
   Set m_Sub = Nothing
   
   ' Unhook this (main) one too!
   Call UnhookWindow(Me.hWnd)
End Sub

Private Function IMessageSink_WindowProc(hWnd As Long, msg As Long, wp As Long, lp As Long) As Long
   Static rMain As RECT
   Static rSub As RECT
   Dim Result As Long
   
   Select Case hWnd
      Case Me.hWnd
         Select Case msg
            Case WM_MOVE, WM_MOVING, WM_SIZE
               ' Move subform to desired position.
               If Not (m_Sub Is Nothing) Then
                  ' Retrieve coordinates for both windows.
                  Call GetWindowRect(hWnd, rMain)
                  Call GetWindowRect(m_Sub.hWnd, rSub)
                  ' Position subform appropriately.
                  Call MoveWindow(m_Sub.hWnd, rMain.Right, rMain.Top, rSub.Right - rSub.Left, rMain.Bottom - rMain.Top, True)
                  ' Store new position of subform.
                  Call GetWindowRect(m_Sub.hWnd, rSub)
               End If
               Result = InvokeWindowProc(hWnd, msg, wp, lp)
               
            Case Else
               ' Pass along to default window procedure.
               Result = InvokeWindowProc(hWnd, msg, wp, lp)
         End Select
      
      Case m_Sub.hWnd
         Select Case msg
            Case WM_ACTIVATE
               ' Have main form retain active titlebar.
               Result = InvokeWindowProc(hWnd, msg, wp, lp)
               Call SendMessage(Me.hWnd, WM_NCACTIVATE, 1, ByVal 0&)
               
            Case WM_MOVING
               ' Copy stored position of subform to the position
               ' the user is trying to drag it to.
               Call CopyMemory(ByVal lp, rSub, Len(rSub))
               Result = 1
               
            Case Else
               ' Pass along to default window procedure.
               Result = InvokeWindowProc(hWnd, msg, wp, lp)
         End Select
      
      End Select
   ' Return desired result code to Windows.
   IMessageSink_WindowProc = Result
End Function

Private Sub m_Sub_Hide()
   ' User clicked [X] on subform.
   Check1.Value = False
End Sub
